summaryrefslogtreecommitdiff
path: root/admin/merge-gnulib
diff options
context:
space:
mode:
authorPaul Eggert <eggert@cs.ucla.edu>2012-05-20 19:33:13 -0700
committerPaul Eggert <eggert@cs.ucla.edu>2012-05-20 19:33:13 -0700
commit9b4ee6166fd8da5f8006a265f775d84e60c15be7 (patch)
tree93ab66a914aecf8114ce919fab4cc34ed0ae0d5b /admin/merge-gnulib
parentb847032c75e0cb4041a8736886e7054beb6f8696 (diff)
downloademacs-9b4ee6166fd8da5f8006a265f775d84e60c15be7.tar.gz
Make merging from gnulib a script, not a makefile action.
Putting it in a makefile has some problems with reflection, as merging from gnulib updates 'configure', which can update the makefile. Putting it in a standalone script breaks this loop. * Makefile.in (gnulib_srcdir, $(gnulib_srcdir), DOS_gnulib_comp.m4) (GNULIB_MODULES, GNULIB_TOOL_FLAGS, sync-from-gnulib): Remove, moving the actions to the script admin/merge-gnulib. * admin/merge-gnulib: New script, with actions moved here from ../Makefile.in.
Diffstat (limited to 'admin/merge-gnulib')
-rwxr-xr-xadmin/merge-gnulib88
1 files changed, 88 insertions, 0 deletions
diff --git a/admin/merge-gnulib b/admin/merge-gnulib
new file mode 100755
index 00000000000..57b71ee4a74
--- /dev/null
+++ b/admin/merge-gnulib
@@ -0,0 +1,88 @@
+#! /bin/sh
+# Merge gnulib sources into Emacs sources.
+# Typical usage:
+#
+# admin/merge-gnulib
+
+# Copyright 2012 Free Software Foundation, Inc.
+
+# This file is part of GNU Emacs.
+
+# GNU Emacs is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# GNU Emacs is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with GNU Emacs. If not, see <http://www.gnu.org/licenses/>.
+
+# written by Paul Eggert
+
+GNULIB_URL=git://git.savannah.gnu.org/gnulib.git
+
+GNULIB_MODULES='
+ alloca-opt
+ careadlinkat crypto/md5 crypto/sha1 crypto/sha256 crypto/sha512
+ dtoastr dup2
+ filemode getloadavg getopt-gnu ignore-value intprops lstat
+ manywarnings mktime pthread_sigmask readlink
+ socklen stdarg stdio strftime strtoimax strtoumax symlink sys_stat
+ warnings
+'
+
+GNULIB_TOOL_FLAGS='
+ --avoid=msvc-inval --avoid=msvc-nothrow
+ --avoid=raise --avoid=threadlib
+ --conditional-dependencies --import --no-changelog --no-vc-files
+ --makefile-name=gnulib.mk
+'
+
+# The source directory, with a trailing '/'.
+# If empty, the source directory is the working directory.
+src=$2
+case $src in
+ */ | '') ;;
+ *) src=$src/ ;;
+esac
+
+# Gnulib's source directory.
+gnulib_srcdir=${1-$src../gnulib}
+
+case $gnulib_srcdir in
+ -*) src=- ;;
+esac
+case $src in
+ -*)
+ echo >&2 "$0: usage: $0 [GNULIB_SRCDIR [SRCDIR]]
+
+ SRCDIR is the Emacs source directory (default: working directory).
+ GNULIB_SRCDIR is the Gnulib source directory (default: SRCDIR/../gnulib)."
+ exit 1 ;;
+esac
+
+test -x "$src"autogen.sh || {
+ echo >&2 "$0: '${src:-.}' is not an Emacs source directory."
+ exit 1
+}
+
+test -d "$gnulib_srcdir" ||
+git clone -- "$GNULIB_URL" "$gnulib_srcdir" ||
+exit
+
+test -x "$gnulib_srcdir"/gnulib-tool || {
+ echo >&2 "$0: '$gnulib_srcdir' is not a Gnulib source directory."
+ exit 1
+}
+
+cp -- "$src"m4/gl-comp.m4 "$src"m4/gnulib-comp.m4 &&
+"$gnulib_srcdir"/gnulib-tool --dir="$src" $GNULIB_TOOL_FLAGS $GNULIB_MODULES &&
+rm -- "$src"m4/gnulib-cache.m4 "$src"m4/warn-on-use.m4 &&
+mv -- "$src"m4/gnulib-comp.m4 "$src"m4/gl-comp.m4 &&
+cp -- "$gnulib_srcdir"/build-aux/texinfo.tex "$src"doc/misc &&
+cp -- "$gnulib_srcdir"/build-aux/move-if-change "$src"build-aux &&
+autoreconf -i -I m4 -- ${src:+"$src"}